package com.alterdekim.hearthhack.util;

import com.google.protobuf.GeneratedMessageV3;
import lombok.NoArgsConstructor;

@NoArgsConstructor
public class PegasusPacket {

    private final int TYPE_BYTES = 4;

    private final int SIZE_BYTES = 4;

    public int size;

    public int type;

    public int context;

    public Object body;

    private boolean sizeRead;

    private boolean typeRead;

    public PegasusPacket(int type, int context, Object body) {
        this.type = type;
        this.context = context;
        this.size = -1;
        this.body = body;
    }

    public PegasusPacket(int type, int context, int size, Object body) {
        this.type = type;
        this.context = context;
        this.size = size;
        this.body = body;
    }


    public Object GetBody() {
        return this.body;
    }

    public boolean IsLoaded() {
        return this.body != null;
    }

    public int Decode(byte[] bytes, int offset, int available) {
        String arg = "";
        int num = 0;
        while (num < 8 && num < available) {
            arg = arg + bytes[offset + num] + " ";
            num++;
        }
        int num2 = 0;
        if (!this.typeRead) {
            if (available < 4) return num2;
            this.type = toInt32_2(bytes, offset);
            this.typeRead = true;
            available -= 4;
            num2 += 4;
            offset += 4;
        }
        if (!this.sizeRead) {
            if (available < 4) return num2;
            this.size = toInt32_2(bytes, offset);
            this.sizeRead = true;
            available -= 4;
            num2 += 4;
            offset += 4;
        }
        if (this.body == null) {
            if (available < this.size) return num2;
            byte[] array = new byte[this.size];
            System.arraycopy(bytes, offset, array, 0, this.size);
            this.body = array;
            num2 += this.size;
        }
        return num2;
    }

    /*public byte[] Encode() {
        if (this.body instanceof GeneratedMessageV3) {
            GeneratedMessageV3 protoBuf = (GeneratedMessageV3) this.body;
            this.size = (int) protoBuf.GetSerializedSize();
            byte[] array = new byte[this.size + 4 + 4];
            Array.Copy(BitConverter.GetBytes(this.Type), 0, array, 0, 4);
            Array.Copy(BitConverter.GetBytes(this.Size), 0, array, 4, 4);
            protoBuf.Serialize(new MemoryStream(array, 8, this.Size));
            return array;
        }
        return null;
    }*/

    private int toInt32_2(byte[] bytes, int index) {
        int a = (int)((int)(0xff & bytes[index]) << 32 | (int)(0xff & bytes[index + 1]) << 40 | (int)(0xff & bytes[index + 2]) << 48 | (int)(0xff & bytes[index + 3]) << 56);
        return a;
    }
}
